import 'package:flutter_test/flutter_test.dart';
import 'package:growthbook_sdk_flutter/src/Utils/utils.dart';
import 'package:growthbook_sdk_flutter/src/evaluator/condition_evaluator.dart';

import '../Helper/gb_test_helper.dart';

void main() {
  group('Condition test', () {
    List evaluateCondition;
    evaluateCondition = GBTestHelper.getEvalConditionData();

    test('Test conditions', () {
      /// Counter for getting index of failing tests.
      int index = 0;
      final failedIndex = <int>[];
      final failedScenarios = <String>[];
      final passedScenarios = <String>[];
      for (final item in evaluateCondition) {
        if (item is List) {
          final localItem = item;
          final evaluator = GBConditionEvaluator();
          final result =
              evaluator.evaluateCondition(localItem[2], localItem[1]);
          final status = localItem[0].toString() +
              "\nExpected Result - " +
              localItem[3].toString() +
              "\nActual result - " +
              result.toString() +
              "\n\n";
          if (localItem[3].toString() == result.toString()) {
            passedScenarios.add(status);
          } else {
            failedScenarios.add(status);
            failedIndex.add(index);
          }
        }
        index++;
      }
      customLogger(
          'Passed Test ${passedScenarios.length} out of ${evaluateCondition.length}');
      expect(failedScenarios.length, 0);
    });
  });
}
/// 
/// This cases are extracted out from the test case file.
/// Failing test cases name : $gt    /$lt     strings - pass
/// Related cases : 3
///  
///  [
///    "$gt    /$lt     strings - fail $gt    ",
///    {
///      "word": {
///        "$gt": "alphabet",
///        "$lt": "zebra"
///      }
///    },
///    {
///      "word": "alphabet"
///    },
///    false
///  ],
///  [
///    "$gt    /$lt     strings - fail $lt    ",
///    {
///      "word": {
///        "$gt": "alphabet",
///        "$lt": "zebra"
///      }
///    },
///    {
///      "word": "zebra"
///    },
///    false
///  ],
///  [
///    "$gt    /$lt     strings - pass",
///    {
///      "word": {
///        "$gt": "alphabet",
///        "$lt": "zebra"
///      }
///    },
///    {
///      "word": "always"
///    },
///    true
///  ],
///  [
///    "$gt    /$lt     strings - fail uppercase",
///    {
///      "word": {
///        "$gt": "alphabet",
///        "$lt": "zebra"
///      }
///    },
///    {
///      "word": "AZL"
///    },
///    false
///  ], 
/// 
